Subject: bug#19390: 25.0.50; `package-activate' is too slow

From: Stefan Monnier <[email-masked]>
Date: Tue, 16 Dec 2014 18:19:14 -0500

> Since we only actually want to reload when upgrading, or reinstalling
> packages, maybe some key logic can move into `package-delete'.

package-delete sounds clearly wrong, since we may very well install
a new version without removing the old version.

> 2. Instead of saving paths, remove elements from the `features' list
> when a package is deleted. Then when a dependency of this package is
> installed (or even autoloaded [0]), it would load the new files, because
> they're not in features.

Eagerly reloading files is much more effective than just removing them
from `features'.  E.g. in the case of autoloaded functions.

        Stefan